<!-- zwUpload  图片上传-->
<template>
  <van-uploader  :max-count="max" preview-size="1rem" ref="zwUpload" v-model="fileList" :multiple="multiple" :after-read="afterRead" />
</template>

<script>
import lrz from "lrz";
export default {
  name: 'zwUpload',
  props: {
    multiple: {
      type: Boolean,
      default: true
    },
    max:{
        type:Number,
        default:5,
    },
    value: {
      type: Array,

    }
  },
  data() {
    return {
      fileList: []
    }
  },
  created() {
    this.initData()
  },
  methods: {
    //初始化方法
    init() {
      this.initData()
    },
    initData() {
      if (this.value) {
        this.fileList = this.value.map(i => {
          return { url: i }
        })
      }
    },

    afterRead(file) {

      if (file instanceof Array) {
        file.forEach(e => {
          this.fileChanged(e.file)
        })
      }else{
         this.fileChanged(file.file)
      }


    },

    fileChanged(file) {
      //上传中
      this.m_loading(this.$t('upload_ing'))
      let quality = file.size / 2014 > 300 ? 0.8 : 1;
      lrz(file, { quality }).then(rst => {
        this.img = rst.base64;

        //ret.file  压缩后的文件
        this.submit(rst);
      });
      // this.submit(this.$refs.file.files[0]);
    },


    submit(rst) {
      //上传中
      this.m_loading(this.$t('upload_ing'))
      let that = this;

      let formData = new FormData();
      formData.append("images", rst.file);
      //  formData.append("image", rst);

      var xhr = new XMLHttpRequest();
      xhr.open("POST", `${this.m_action}`, true);
      xhr.withCredentials = true;
      xhr.timeout = 10000; //超时
      xhr.onload = function () {
        if (xhr.status === 200 || xhr.status === 304) {
          //  console.log('success',this.response)
          let res = JSON.parse(this.response);
           that.m_hideLoading()
          let code = res.code
          if(code!=0){
             that.$emit("error", res);
              that.m_toast(res.message)
            return
          }

         
          // that.$emit("success", that.imgInfo);
          that.success(res)

        }
      };

      //错误上传
      xhr.onerror = function (res) {
        console.log("上传错误");
        that.m_hideLoading()
        that.m_toast('上传失败')
        that.$emit("error", res);
      };

      xhr.ontimeout = function (res) {
        console.log("上传超时");
        that.m_hideLoading()
        that.m_toast('上传超时')
        that.$emit("error", res);

      };

      xhr.send(formData);
    },

    success(res) {
      console.log(res, '成功回调')
      let img = res.data
      this.fileList.push({url:img})
      this.fileList = this.fileList.filter(i=>i.url)


    },

    //生成名字
    rename(rst) {
      return new Date().getTime() + (new Array(2).fill().map(i => (~~(Math.random() * 10))).join('')) + '.' + rst.origin.name.split('.').reverse()[0]
    },

    getImgUrl(){
        return this.fileList.map(i=>i.url)
    }

  },
}

</script>
<style lang='scss' scoped>
</style>